"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const parse_values_1 = require("@react-jsonschema-form-utils/parse-values");
const get_input_type_1 = __importDefault(require("./utils/get-input-type"));
const get_mui_props_1 = __importDefault(require("./utils/get-mui-props"));
const get_text_area_props_1 = __importDefault(require("./utils/get-text-area-props"));
const onChangeHandler = (onChange, type, options) => (e) => {
    const valueUI = parse_values_1.coerceValue(type, e.target.value, options);
    const valueForm = parse_values_1.coerceValue(type, e.target.value, Object.assign(Object.assign({}, options), { isFormData: true }));
    if (valueForm !== undefined)
        onChange(valueForm, valueUI);
};
exports.default = ({ onChange, onBlur, type, options, uiSchema, htmlid, schema = {}, }) => {
    const defaultOptions = ['useLocaleString'];
    const materialProps = Object.assign({ inputProps: typeof options.inputProps === 'object'
            ? Object.assign({}, options.inputProps) : {} }, Object.keys(options)
        .filter((key) => !defaultOptions.includes(key))
        .reduce((obj, key) => (Object.assign({}, obj)), {}));
    const props = Object.assign(Object.assign(Object.assign({ onChange: onChange && onChangeHandler(onChange, type, options), onBlur: onBlur && onChangeHandler(onBlur, type, options), label: schema.title || '', inputProps: Object.assign({ id: htmlid }, materialProps.inputProps) }, get_text_area_props_1.default(uiSchema['ui:widget'])), get_mui_props_1.default(uiSchema)), materialProps);
    if (!options.useLocaleString) {
        props.type = get_input_type_1.default(type, uiSchema);
    }
    return props;
};
//# sourceMappingURL=input.props.js.map